#define ASM
#define STANDALONE
#include "hardware.h"

#include "fat.h"

	.import _ReadDiskSector

	.import _GetByte
	.import _GetWord
	.import _GetLong

// auto u_int16 InitFileSystem(void) {

#ifdef RECORDER
	.sect code,InitFileSystemR	// 115 words -> 85 -> 79
	.export _InitFileSystemR
_InitFileSystemR:	// PROLOGUE
#else
	.sect code,InitFileSystem	// 115 words -> 85 -> 79
	.export _InitFileSystem
_InitFileSystem:	// PROLOGUE
#endif
	// stack increased in the caller
	stx D1,(I6)+1 ; sty I2,(I6)
	//ldc 512,MR0
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6)+1 ; sty C0,(I6)
	stx C1,(I6)+1 ; sty D0,(I6)

//     ReadDiskSector(fatInfo.currentSector = 0);

	ldc _fatInfo+CURRENTSECTOR,I2
#ifdef FATINFO_IN_Y
	and A,NULL,A	; sty LR0,(I6)
	sty a0,(i2)+1	; stx MR0,(I6)+2
	call _ReadDiskSector	// Register parameter: A, pass by value
	sty a1,(i2)-1
#else
	and A,NULL,A	; stx MR0,(I6)
	stx a0,(i2)+1	; sty LR0,(I6)+2
	call _ReadDiskSector	// Register parameter: A, pass by value
	stx a1,(i2)-1
#endif

//     currentSector = GetLong(0x1c6);
//     ReadDiskSector(currentSector);

#ifndef RECORDER	// check for boot sector instead of partition table
	call _GetLong
	ldc 0x36,c0
	ldc ('A'<<8)|'F',C0
	ldc ('1'<<8)|'T',C1	// 'FAT1' i.e. FAT12 or FAT16
	sub a,c,a	; ldx (i6)+3,null
	nop
	jzs $6
	ldc ('3'<<8)|'T',C1	//and a,null,a if jump taken, A is already 0!

	call _GetLong
	ldc 0x52,c0	//FAT32
	ldc ('A'<<8)|'F',C0	// 'FAT3' i.e. FAT32
	sub a,c,a	; ldx (i6)+1,null
	nop
	jzs $6
	ldc 0x1c6,C0		//and a,null,a if jump taken, A is already 0!

	// Get boot sector location
	call _GetLong	// Register parameter: C0, pass by value
	ldx (I6)+1,NULL
$6:
#ifdef FATINFO_IN_Y
	sty A0,(I2)+1		//CURRENTSECTOR
	call _ReadDiskSector	// Register parameter: A, pass by value
	sty A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
#else
	stx A0,(I2)+1		//CURRENTSECTOR
	call _ReadDiskSector	// Register parameter: A, pass by value
	stx A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
#endif

#else
	//ldx (I6)+1,NULL
	call _GetLong	// Register parameter: C0, pass by value
	ldc 0x1c6,C0

#ifdef FATINFO_IN_Y
	sty A0,(I2)+1	; ldx (I6)+3,NULL	//CURRENTSECTOR
	call _ReadDiskSector	// Register parameter: A, pass by value
	sty A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
#else
	stx A0,(I2)+1	; ldy (I6)+3,NULL	//CURRENTSECTOR
	call _ReadDiskSector	// Register parameter: A, pass by value
	stx A1,(I2)+(FILSYSTYPE-CURRENTSECTOR-1)
#endif
#endif

//     {
// 	u_int16 BPB_BlksPerSec;

	//fatInfo.FilSysType = GetWord(54+3); /* 0x3231 for FAT12 */
	call _GetWord
	ldc 54+3,C0
#ifdef FATINFO_IN_Y
	sty a0,(i2)+(BPBROOTENTCNT-FILSYSTYPE)
#else
	stx a0,(i2)+(BPBROOTENTCNT-FILSYSTYPE)
#endif

// 	BPB_RootEntCnt = GetWord(17);

	call _GetWord	// Register parameter: C0, pass by value
	ldc 17,C0

// 	IS_FAT_32 = BPB_RootEntCnt ? 0 : 1;

#ifdef FATINFO_IN_Y
	add A0,NULL,D1	; sty A0,(I2)+(ISFAT32-BPBROOTENTCNT+5)
#else
	add A0,NULL,D1	; stx A0,(I2)+(ISFAT32-BPBROOTENTCNT+5)
#endif
	ldc 11,C0
	jzs $5
	sub NULL,ONES,A1	; ldx (i2)-5,null

	and NULL,NULL,A1
$5:

// 	BPB_BlksPerSec = GetWord(11) >> 9;

	call _GetWord	// Register parameter: C0, pass by value
#ifdef FATINFO_IN_Y
	sty A1,(I2)+(FATSECTORSPERCLUSTER-ISFAT32-4) ; ldx (I6)+1,NULL
#else
	stx A1,(I2)+(FATSECTORSPERCLUSTER-ISFAT32-4) ; ldy (I6)+1,NULL
#endif

	ldc 128,A1
	muluu A1,A0	; ldx (i2)+4,null	// >> 9
	add NULL,P,A ; ldx (I6)+1,NULL		// BPB_BlksPerSec = A1

// 	fatSectorsPerCluster = GetByte(13)  * BPB_BlksPerSec;

	call _GetByte	// Register parameter: C0, pass by value
	ldc 13,C0

	muluu A0,a1	; mv a1,D0	// BPB_BlksPerSec = D0
	add NULL,P,B	; ldy (I6)+1,NULL
#ifdef FATINFO_IN_Y
	sty B0,(I2)+(CURRENTSECTOR-FATSECTORSPERCLUSTER)
#else
	stx B0,(I2)+(CURRENTSECTOR-FATSECTORSPERCLUSTER)
#endif

// 	fatStart = currentSector +
// 	    (u_int32)GetWord(14)  * BPB_BlksPerSec;
// 	rootStart = GetWord(22);

	call _GetWord	// Register parameter: C0, pass by value
	ldc 14,C0

#ifdef FATINFO_IN_Y
	ldy (I2)+1,C0	//CURRENTSECTOR
	muluu A0,D0	; ldy (I2)+(FATSTART-CURRENTSECTOR-1),C1//BPB_BlksPerSec
	add C,P,A	; ldx (i6)+1,null
	sty A0,(I2)+1
	and a1,null,a1	; sty A1,(I2)+(ROOTSTART-FATSTART-1)
#else
	ldx (I2)+1,C0	//CURRENTSECTOR
	muluu A0,D0	; ldx (I2)+(FATSTART-CURRENTSECTOR-1),C1//BPB_BlksPerSec
	add C,P,A	; ldx (i6)+1,null
	stx A0,(I2)+1
	and a1,null,a1	; stx A1,(I2)+(ROOTSTART-FATSTART-1)
#endif
	call _GetWord
	ldc 22,C0

#ifdef FATINFO_IN_Y
	add A0,NULL,A0	; sty A0,(I2)+1	//ROOTSTART
	sty A1,(I2)+(ISFAT32-ROOTSTART-1)	; ldx (I6)+1,NULL
	jzc $1
	ldy (I2)+(ROOTSTART-ISFAT32),A0
#else
	add A0,NULL,A0	; stx A0,(I2)+1	//ROOTSTART
	stx A1,(I2)+(ISFAT32-ROOTSTART-1)	; ldy (I6)+1,NULL
	jzc $1
	ldx (I2)+(ROOTSTART-ISFAT32),A0
#endif

// 	if (rootStart == 0) {
// 	    if (!IS_FAT_32)
// 		return 0x0b;

	add A0,NULL,A0	; ldx (I6)-1,NULL	// update flags
	ldc 36,C0
	jzs $0
	ldc 11,A0

// 	    rootStart = GetLong(36);

	call _GetLong	// Register parameter: C0, pass by value
	ldx (I6)+1,NULL

#ifdef FATINFO_IN_Y
	sty A0,(I2)+1	; ldx (I6)+1,NULL	//ROOTSTART
	sty A1,(I2)-1
#else
	stx A0,(I2)+1	; ldy (I6)+1,NULL	//ROOTSTART
	stx A1,(I2)-1
#endif
// 	}
// 	rootStart = rootStart * (GetByte(16)  * BPB_BlksPerSec)
// 	    + fatStart;

$1:
	call _GetByte	// Register parameter: C0, pass by value
	ldc 16,C0

#ifdef FATINFO_IN_Y
	muluu A0,D0	; ldy (I2)+1,B0	//ROOTSTART	// BPB_BlksPerSec *
	add NULL,P,C	; ldy (I2)+(FATSTART-ROOTSTART-1),B1
	muluu C0,B1	; mv C0,B1	// 16x32
	add NULL,P,A	; ldy (I2)+1,C0	//FATSTART
	muluu B1,B0	; ldy (I2)+(FATSECTORSPERCLUSTER-FATSTART-1-2),C1
	add A0,P,A	; ldy (i2)+2,null
	add A,C,C	; ldy (I2)+(ROOTSTART-FATSECTORSPERCLUSTER+1),B0
#else
	muluu A0,D0	; ldx (I2)+1,B0	//ROOTSTART	// BPB_BlksPerSec *
	add NULL,P,C	; ldx (I2)+(FATSTART-ROOTSTART-1),B1
	muluu C0,B1	; mv C0,B1	// 16x32
	add NULL,P,A	; ldx (I2)+1,C0	//FATSTART
	muluu B1,B0	; ldx (I2)+(FATSECTORSPERCLUSTER-FATSTART-1-2),C1
	add A0,P,A	; ldy (i2)+2,null
	add A,C,C	; ldx (I2)+(ROOTSTART-FATSECTORSPERCLUSTER+1),B0
#endif
	and A1,NULL,A1	; mv D1,a0
	ldc -4,D1

// 	dataStart = rootStart + (BPB_RootEntCnt >> 4)
// 	    - (fatSectorsPerCluster << 1);

	ashl a,D1,a	; mv a1,b1
	add A,C,A	; ldx (i2)-1,null
#ifdef FATINFO_IN_Y
	add B0,B0,B0	; sty C0,(I2)+1	//ROOTSTART
	sub A,B,A	; sty C1,(I2)+(DATASTART-ROOTSTART-1)
	sty A0,(I2)+1	; and NULL,NULL,A0	//DATASTART
	sty A1,(I2)
#else
	add B0,B0,B0	; stx C0,(I2)+1	//ROOTSTART
	sub A,B,A	; stx C1,(I2)+(DATASTART-ROOTSTART-1)
	stx A0,(I2)+1	; and NULL,NULL,A0	//DATASTART
	stx A1,(I2)
#endif
//     }
//     return 0;

$0:	ldx (I6)-1,MR0 ; ldy (I6),LR0
	ldx (I6)-1,C1 ; ldy (I6),D0
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	jr
	ldx (I6)-1,D1 ; ldy (I6),I2

	// FUNCTION InitFileSystem(): stack usage ~ 2 x (11 + 0) = 2 x 11 words

	.end
