#define ASM
#define STANDALONE
#include "hardware.h"

#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */


#if 1
	.sect code,SpiSendReceiveSpi
	.export _SpiSendReceiveSpi
_SpiSendReceiveSpi:
// auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);
	stx d0,(i6)+1	; sty c0,(i6)
	ldc SPI_xCS2,c0	//SPI CLK up, SPI CS down, MMC CLK down
	.import _SpiCommon
	j _SpiCommon
	ldc 0,d0	//SPI CLK down. SPI CS down, MMC CLK down
#else
	/* Slower version */
	// Slower version, 2 words longer :-( Use with SAVE_STUFF.

// auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);
	.sect code,SpiSendReceiveSpi
	.export _SpiSendReceiveSpi
_SpiSendReceiveSpi:
	stx d0,(i6)+1	; sty c0,(i6)

	ldc SPI_xCS2,c0	//SPI CLK up, SPI CS down, MMC CLK down
	ldc 0,d0	//SPI CLK down. SPI CS down, MMC CLK down

	stx lc,(i6)+1	; sty c1,(i6)
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)+1
	stx lr0,(i6)	; sty a1,(i6)

	ldc SER_DREQ,i7
	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
	.import _SpiDelay
	call _SpiDelay
	ldy (i6),i5	//get saved a1

	stx i5,(i7)+(GPIO_IDATA-SER_DREQ)	//data out
	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	//data in, note pipeline!
	ashl a1,c1,a1	; stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA)	// clkup
	lslc a,a
	call _SpiDelay
	sty a1,(i6)

	stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clkdown
$0:
	ldx (i6)-1,lr0
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0	// 21 words
#endif


// void SaveWord(register __c0 u_int16 addr, register __c1 u_int16 value) {

	.sect code,SaveWord	// 41 words -> 27
	.export _SaveWord
_SaveWord:	// PROLOGUE
	ldx (I6)+1,NULL
	stx A0,(I6)+1 ; sty I0,(I6)

//     USEX(GPIO_ODATA) &= ~(SPI_xCS2|SPI_xCS);

	ldc GPIO_ODATA,I0
	ldx (I0),A0/*V*/	; sty A1,(i6)+1
	ldc ~(SPI_xCS2|SPI_xCS),A1
	and A0,A1,d0		; stx d0,(i6)
	stx d0,(I0)/*V*/	; sty lr0,(i6)+2

//     SpiSendReceiveSpi(SPI_WREN<<8, 8);

	ldc 8,A1
	call _SpiSendReceiveSpi
	ldc 0x0600,A0

//    USEX(GPIO_ODATA) |= SPI_xCS;
//    SpiDelay();
//    USEX(GPIO_ODATA) &= ~SPI_xCS;

	ldc SPI_xCS,A1
	or d0,a1,a1
	.import _SpiDelay
	call _SpiDelay
	stx a1,(i0)	// in delay slot.
	ldc 8,A1
	stx d0,(i0)

//     SpiSendReceiveSpi(SPI_WRITE<<8, 8);

	call _SpiSendReceiveSpi
	ldc 0x0200,A0

//     SpiSendReceiveSpi(addr , 16);
//     SpiSendReceiveSpi(value, 16);

	ldc 16,A1
	call _SpiSendReceiveSpi
	ldx (I6)+1,NULL ; add C0,NULL,A0

	ldc 16,A1
	call _SpiSendReceiveSpi
	ldx (I6)+1,NULL ; add C1,NULL,A0

//     USEX(GPIO_ODATA) |= SPI_xCS|SPI_xCS2;

	ldc SPI_xCS|SPI_xCS2,A1
	ldx (I0),A0/*V*/	; ldy (i6),lr0
	or A0,A1,A1		; ldx (i6)-1,d0
	stx A1,(I0)/*V*/	; ldy (i6)-1,A1

	jr
	ldx (I6)-1,A0 ; ldy (I6),I0

	.end
